/*
** cursorp.h
**
** Private header file for TWS cursors
**
** Copyright (C) 1994 by
** Dean Clark
** Box 37464
** Albuquerque, NM  87176
** All rights reserved
*/

#ifndef CURSORP_H
#define CURSORP_H

typedef struct {
    int             hotx, hoty;
    unsigned char   *foremask, *backmask;
} CursorType;

#define MAINCURSOR      0
#define MOVECURSOR      1
#define GRAPHCURSOR     2
#define URRESIZECURSOR  3
#define ULRESIZECURSOR  4
#define LLRESIZECURSOR  5
#define LRRESIZECURSOR  6
#define USERCURSOR      7

#define ARROWCURSOR     (CursorType *)0x0001
#define DBLARROWCURSOR  (CursorType *)0x0002
#define ULEFTARROWCURSOR (CursorType *)0x0003
#define URIGHTARROWCURSOR (CursorType *)0x0004
#define LLEFTARROWCURSOR (CursorType *)0x0005
#define LRIGHTARROWCURSOR (CursorType *)0x0006
#define CROSSCURSOR     (CursorType *)0x0007
#define HOURGLASSCURSOR (CursorType *)0x0008

#endif

