/*
** MOUSE.H
**
** Include file for mouse routines
*/

#define LEFT_MOUSE_PRESS    0xff01
#define RIGHT_MOUSE_PRESS   0xff02
#define LEFT_MOUSE_RELEASE  0xff11
#define RIGHT_MOUSE_RELEASE 0xff12

#define M_RESET             0
#define M_SHOW_CURS         1
#define M_HIDE_CURS         2
#define M_GET_STATUS        3
#define M_SET_CURS          4
#define M_GET_PRESS         5
#define M_GET_REL           6
#define M_SET_X_BOUNDS      7
#define M_SET_Y_BOUNDS      8
#define M_SET_G_CURS        9
#define M_SET_T_CURS        10
#define M_READ_MOTION      11
#define M_DISABLE           31
#define M_ENABLE            32

#define MOUSE_TEXT_MODE     0

extern int mouse_text_x;
extern int mouse_text_y;
extern int mouse_grph_x;
extern int mouse_grph_y;
extern int mouse_initialized;

extern void mouse(int *m1, int *m2, int *m3, int *m4);
extern int check_mouse_driver();
extern int init_mouse(int gd, int gm);
extern int mouse_reset(void);
extern void move_mouse(int x, int y);
extern void mouse_on(void);
extern void mouse_off(void);
extern void mouse_grph_posn(int *x, int *y);
extern int mouse_in_box(int graphflag, int left, int right, int top, int bottom);
extern int button_release(int b);
extern int button_press(int b);
extern int button_state(void);
extern unsigned int mouse_trigger(int button_dir);
extern void set_mouse_cursor(unsigned int *curs, int x, int y);
void mouse_movement(int *x, int *y);


