/*
** smborder.h
*/
#ifndef SMBORDER_INC
#define SMBORDER_INC

#include    <smcolor.h>
#include    <smgadget.h>
#include    <smevent.h>
#include    <smwindow.h>

#define twsBORDERHLINE  1
#define twsBORDERVLINE  2
#define twsBORDERBOX    3

#define twsBORDERFLAT   1
#define twsBORDERBEVEL  2
#define twsBORDERSCULPT 3
#define twsBORDERRIDGE  4
#define twsBORDERLRIDGE 5

#define twsBORDERLEFT   1
#define twsBORDERRIGHT  2
#define twsBORDERCENTER 3

typedef struct {
    GadgetType  *gadget;
    char        *label;
    int         type;
    int         style;
    int         position;
    int         thick;
    ColorType   *color;
} BorderType;

/*
** Function prototypes
*/
#define SM_GetBorderLabel(x)    ((x)->label)
#define SM_GetBorderColor(x)    ((x)->color)
#define SM_GetBorderType(x)     ((x)->type)
#define SM_GetBorderStyle(x)    ((x)->style)
#define SM_GetBorderPosition(x) ((x)->position)
#define SM_GetBorderThick(x)    ((x)->thick)

BorderType *SM_CreateBorder(WindowType *w,
                            RectType *r,
                            char *label,
                            int position,
                            int type,
                            int style,
                            int thick,
                            ColorType *color);
int DrawBorder(GadgetType *g);
int DestroyBorder(GadgetType *g);
int BorderProc(GadgetType *g, EventType *ev);
void SM_DestroyBorder(BorderType *b);


#endif
