/*
** smbutton.h
**
** Public header file for button gadget.
**
** Copyright 1992, 1993 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
** Revision history:
**
** 1 Mar 1992
** Original version
**
** 14 Sept 1992
** Revised based on 'generic' gadget type. Specific gadgets only need
** their unique functionality; common functionality is provided by
** generic gadget 'superclass'.
**
** 12 Dec 1994
** Separated structure definition (smbuttop.h) from interface definition
**
*/

#ifndef SMBUTTON_H
#define SMBUTTON_H

#include <smbuttop.h>
#include <smwindop.h>
#include <smpixmpp.h>

#define SM_GetButtonTransparency(b)     ((b)->transparent)
#define SM_SetButtonTransparency(b,i)   ((b)->transparent = (i))

/*
** Function prototypes
*/
void        SM_ActivateButton(ButtonType *b);
ButtonType *SM_CreateButton(WindowType  *w,
                            RectType    *r,
                            char        *label,
                            void        *data,
                            int         (*action)());
void        SM_DeactivateButton(ButtonType *b);
int         SM_DestroyButton(ButtonType *b);
// int         SM_GetButtonActive(ButtonType *b);
// ColorType  *SM_GetButtonColor(ButtonType *b);
// void       *SM_GetButtonData(ButtonType *b);
// int         SM_GetButtonIsdefault(ButtonType *b);
// char       *SM_GetButtonLabel(ButtonType *b);
// ColorType  *SM_GetButtonLabelcolor(ButtonType *b);
// PixmapType *SM_GetButtonPixmap(ButtonType *b);
#define SM_GetButtonActive(b)   ((b)->active)
#define SM_GetButtonColor(b)    ((b)->color)
#define SM_GetButtonData(b)     ((b)->data)
#define SM_GetButtonIsdefault(b)    ((b)->isdefault)
#define SM_GetButtonLabel(b)    ((b)->label)
#define SM_GetButtonLabelcolor(b)   ((b)->labelcolor)
#define SM_GetButtonPixmap(b)   ((b)->pixmap)
#define SM_GetButtonPcolor(b)   ((b)->pcolor)
#define SM_GetButtonPlabelcolor(b)  ((b)->plabelcolor)
void        SM_SetButtonActive(ButtonType *b, int a);
ColorType  *SM_SetButtonColor(ButtonType *b, ColorType *c);
// int         SM_SetButtonData(ButtonType *b, void *data);
// int         SM_SetButtonGraphproc(ButtonType *b, int (*f)());
int         SM_SetButtonIsdefault(ButtonType *b, int i);
#define SM_SetButtonData(b,d)   ((b)->data = (d))
#define SM_SetButtonGraphproc(b,p)   ((b)->graphproc = (p))
#define SM_SetButtonProc(b,p)   ((b)->graphproc = (p))
#define SM_SetButtonRepeat(b,r) ((b)->repeat = (r))
int         SM_SetButtonLabel(ButtonType *b, char *label);
ColorType  *SM_SetButtonLabelColor(ButtonType *b, ColorType *c);
ColorType  *SM_SetButtonPushedLabelColor(ButtonType *b, ColorType *c);
ColorType  *SM_SetButtonPushedColor(ButtonType *b, ColorType *c);
void        SM_SetButtonPixmap(ButtonType *b, PixmapType *p, int x, int y);
// int         SM_SetButtonProc(ButtonType *b, int (*proc)());
int         SM_SetButtonRect(ButtonType *b, RectType *r);
int         SM_SetButtonAlign(ButtonType *b, int align);


#endif

