/*
** smbuttop.h
**
** Private header file for button gadget.
**
** Copyright 1994 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
** Revision history:
**
** 12 Dec 1994
** Original version
**
*/

#ifndef SMBUTTOP_H
#define SMBUTTOP_H

#include <smtypes.h>
#include <smgadgtp.h>
#include <smpixmpp.h>

/*
** Type definitions
*/

/*
** Button action function
*/
typedef struct _but {
    GadgetType  *gadget;                /* 'Superclass' gadget              */
    char        *label;                 /* Text for button interior         */
    int         align;                  /* Button label horizontal alignment*/
    ColorType   *color;                 /* Button face color                */
    ColorType   *pcolor;                /* Button face color when pushed    */
    ColorType   *up_bevel_color;        /* Bevel colors                     */
    ColorType   *down_bevel_color;
    ColorType   *labelcolor;            /* Color for text label             */
    ColorType   *plabelcolor;           /* Color for text label when pushed */
    void        *data;                  /* User-specified data for button   */
    PixmapType  *pixmap;                /* Button pixmap                    */
    int         pmx, pmy;               /* Pixmap offset into the button    */
    int         active;                 /* if TRUE button is active         */
    int         isdefault;              /* if TRUE button activate by Enter */
    int         pushed;                 /* If True button is pushed in      */
    int         repeat;                 /* If True button has 'typematic'   */
    int         (*graphproc)(struct _but *);    /* Draw in the button       */
} ButtonType;

#endif
