/*
** smchkbx.h
**
** Header file for API routines for the checkbox control type.
**
** Copyright 1992, 1993 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
*/

#ifndef SMCHKBX_H
#define SMCHKBX_H

#include <smwindop.h>
#include <smchkbxp.h>

/*
** Function prototypes
*/
CheckboxType *SM_AddCheckbox(
    CheckboxGroupType   *group,         /* Checkbox group to add to         */
    RectType            *box,           /* Boundary RectType for checkbox   */
    char                *label,         /* Text label                       */
    int                 buttonpos,      /* LEFT or RIGHT for text           */
    int                 selected,       /* TRUE if this checkbox is on      */
    void                *data,          /* User data                        */
	int                 (*action)());   /* Function called when selected    */

CheckboxType *SM_CreateCheckbox(
    WindowType  *w,
    RectType *box,
    char    *label,                     /* Checkbox label                   */
    int     buttonpos,                  /* To left or right of cbox         */
    int     selected,                   /* TRUE if checkbox is "on"         */
    void    *data,                      /* User data                        */
	int     (*action)());               /* Function called when cbox selected*/

CheckboxGroupType *SM_CreateCheckboxGroup(
    WindowType  *w,                     /* Parent window                    */
    RectType    *r,                     /* Group boundary                   */
    char        *label,                 /* Group title                      */
    int         draw,                   /* Draw boundary, title if True     */
    int         (*action)());           /* Group user proc                  */

int     SM_DestroyCheckbox(CheckboxType *c);
void    SM_DestroyCheckboxGroup(CheckboxGroupType *c);
// int     SM_GetCheckboxState(CheckboxType *c);
// int     SM_GetCheckboxType(CheckboxType *c);
// int     SM_SetCheckboxLabel(CheckboxType *c, char *d);
// int     SM_SetCheckboxProc(CheckboxType *c, int (*f)());
int     SM_SetCheckboxSelected(CheckboxType *cb);
int     SM_SetCheckboxState(CheckboxType *c, int selected);
void    SM_SetCheckboxType(CheckboxType *c, int type);

#define SM_GetCheckboxData(c)   ((c)->data)
#define SM_GetCheckboxLabel(c)  ((c)->label)
#define SM_GetCheckboxState(c)  ((c)->selected)
#define SM_GetCheckboxType(c)   ((c)->type)
#define SM_SetCheckboxData(c,d) ((c)->data = (d))
#define SM_SetCheckboxProc(c,f) ((c)->gadget->userproc = (f))


#endif
