/*
** smchkbxp.h
**
** Private header file for the checkbox control type.
**
** Copyright 1994 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
*/

#ifndef SMCHKBXP_H
#define SMCHKBXP_H

#include <smgadgtp.h>

#define     SMCBOXSQUARE  0
#define     SMCBOXBUTTON  1
#define     SMCBOXOVAL    2

/*
** Type definitions
*/

/*
** The Checkbox
**
** This is usually a depressed/undepressed small box.  Often the
** interior is shaded differently when the box is depressed.  Usually the
** box sits next to a short text descriptor or perhaps an icon.
*/
typedef struct _cb {
    GadgetType	*gadget;				/* Superclass gadget				*/
	char        *label;
    int         type;                   /* Visual type                      */
    int         buttonpos;              /* Position for label              	*/
    int         selected;               /* TRUE if button checked           */
	void        *data;                  /* User-specified data for button   */
    void        *group;                 /* Is this checkbox in a group?     */
} CheckboxType;



/*
** CheckboxGroup
**
** A collection of checkboxes. Only one of the group can be active at a time
*/
typedef struct _group {
    GadgetType		*gadget;			/* Superclass						*/
	CheckboxType    *selected;          /* Active checkbox                  */
    int             selfadjust;         /* If true group boundary autoadjust*/
    int             outline;            /* If true group bounds is drawn    */
    char            *title;             /* Group title                      */
} CheckboxGroupType;

#endif
