/*
** smgadget.h
**
** Public header for the window gadget list manager
**
** Copyright 1992, 1993 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
*/       

#ifndef SMGADGET_H
#define SMGADGET_H

#include    <smwindop.h>
#include    <smgadgtp.h>

/*
** Function prototypes
*/
void        CloseGadgets(GadgetType *g);
GadgetType *SM_AddGadget(WindowType *w,      /* Parent window               */
                         int type,           /* Kind of control             */
                         void *gadget,       /* Pointer to specific gadget  */
                         unsigned msg,       /* Messages the gadget respo   */
                         RectType *r,        /* Gadget boundary             */
                         int (*draw)(),      /* Gadget's draw procedure     */
                         int (*deleteproc)(),/* Gadget deallocation         */
                         int (*shellproc)(), /* Gadget shell procedure      */
                         int (*proc)());     /* Gadget's user function      */

int         SM_AttachGadget(WindowType *w, GadgetType *newgadget);
int         SM_CloseGadgets(void *g);
int         SM_DestroyGadget(GadgetType *g);
WindowType *SM_GadgetToWindow(void *gadget);
GadgetType *SM_GetFocusGadget(WindowType *w);
ColorType  *SM_GetGadgetBackcolor(void *g);
RectType   *SM_GetGadgetBound(void *g);
ColorType  *SM_GetGadgetForecolor(void *g);
GadgetType *SM_GetGadgets(WindowType *w);
WindowType *SM_GetGadgetWindow(void *g);
int         SM_GetGadgetType(GadgetType *g);
void       *SM_GetGadgetGadget(GadgetType *g);
int         SM_GetGadgetMsg(void *g);
GadgetType *SM_GetGadgetSuperclass(void *g);
GadgetType *InitGadget(WindowType *w);
int         SM_RefreshGadgets(WindowType *w);
void        SM_SetFocusGadget(void *g);
void        SM_SetGadgetBackcolor(void *g, ColorType *c);
int         SM_SetGadgetBound(void *a, RectType *r);
void        SM_SetGadgetForecolor(void *g, ColorType *c);
int         SM_SetGadgetMsg(void *g, int msg);
int         SM_SetGadgetDrawproc(void *g, int (*f)());
int         SM_SetGadgetDeleteproc(void *g, int (*f)());
void        SM_SetGadgetRedrawFlag(void *g, int flg);
int         SM_SetGadgetUserproc(void *g, int (*f)());
void        SM_SetGadgetFont(void *a, char *fontname);
void        SM_SetGadgetFontSize(void *a, int width, int height);
void        SM_SetGadgetFontFacing(void *a, int face);
void        SM_AdjustGadgetBound(void *g, int dx, int dy, int dwidth, int dheight);
void        SM_GetGadgetFontSize(void *ptr, int *width, int *height);
void        GadgetIntersectRect(WindowType *w, RectType *r);

#endif


