/*
** smgadgtp.h
**
** Private header for the window gadget list manager
**
** Copyright 1994 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
*/       

#ifndef SMGADGTP_H
#define SMGADGTP_H

#include    <smtypes.h>
#include    <smeventp.h>

struct _win ;                           /* "Forward" definition for window  */

/*
** The foundation gadget class
*/
typedef struct _gadget {
    void        *gadget;                /* Specific gadget fields struct    */
    struct _win *parentwin;             /* Window containing the gadget     */
    RectType    bound;                  /* Sensitive region for the gadget  */
    FontType    font;                   /* Font to draw gadget with         */
    int         width, height;          /* Font width and height            */
    int         face;                   /* Font facing                      */
    short       gcode;                  /* Keyboard code (accelerator)      */
    int         type;                   /* Type of gadget subclassed        */
    unsigned    msg;                    /* Event types gadget responds to   */
    int         nofree;                 /* If True gadget not freed on close*/
    int         redraw;                 /* If True gadget needs redrawing   */
    ColorType   *backcolor, *forecolor; /* Gadget drawing colors            */
    int         (*drawproc)(struct _gadget *);      /* Draw the gadget      */
    int         (*deleteproc)(struct _gadget *);    /* Delete gadget        */
    int         (*shellproc)(struct _gadget *,EventType *);
    int         (*userproc)(void *);    /* Gadget user procedure            */
    struct _gadget *next, *prev;        /* Links                            */
} GadgetType;

/*
** A 'generic' gadget that any window gadget can be cast to to
** retrieve the gadget class
*/
typedef struct {
    GadgetType  *gadget;
} AnyGadgetType;


/* #include    <smwindop.h> */

#endif
