/*
** smgraphp.h
**
** Private header file for graphics state definition.
**
** Copyright 1994 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
** Revision history:
**
** 12 December 1994
** Original
*/

#ifndef SMGRAPHP_H
#define SMGRAPHP_H

#include    <smtypes.h>

/*
** The graphics state
*/
typedef struct {
    int         gx, gy;                 /* Graphics cursor location         */
    int         tx, ty;                 /* Text cursor location             */
    ColorType   *palette;               /* Color palette                    */
    int         ncolors;                /* Number of colors in the palette  */
    ColorType   *forecolor;             /* Graphics foreground color        */
    ColorType   *backcolor;             /* Graphics background color        */
    ColorType   *tcolor;                /* Text color                       */
    int         penmode;                /* Xor, And, etc.                   */
    int         linewidth;
    int         linestyle;
    int         textmode;
    FontType    font;                   /* Text font                        */
    RectType    devicecanvas;           /* Drawable region in device coords */
    RectType    canvas;                 /* Drawable region in user coords   */
    char        *save_file;             /* Save-under storage file          */
    int         step;                   /* Number of save-under buffers     */
    RectType    buffrect[64];
    int         canvasborder;           /* Flag for drawable region border  */
} GraphStateType;

#endif
