/*
** smmenu.h
**
** Header file for menu controls
**
** Copyright 1992, 1993 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
** Mon  05-18-1992
*/

#ifndef SMMENU_H
#define SMMENU_H

#include <smmenup.h>
#include <smwindow.h>

#define ACTION_ITEM     1               /* Menu item types                  */
#define SUBMENU_ITEM    2
#define MENU_DIVIDER    4
         
/*
** Function prototypes
*/
MenuType   *SM_AddMenuItem (MenuType *menu,
                            int      type,
                            char     *label,
                            int      (*function)(),
                            MenuType *sub);
MenuType   *SM_CreateMenu(void);
int         SM_DestroyMenu(MenuType *m);
int         SM_GetMenuActive(MenuType *m);
char       *SM_GetMenuLabel(MenuType *m);
void        SM_SetMenuActive(MenuType *m);
void        SM_SetMenuInactive(MenuType *m);
int         SM_SetMenuLabel(MenuType *m, char *label);
int         SM_SetMenuProc(MenuType *m, int (*proc)());


#endif
