/*
** smmenup.h
**
** Private header file for menu controls
**
** Copyright 1992, 1993 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
** Mon  05-18-1992
*/

#ifndef SMMENUP_H
#define SMMENUP_H

#include <smtypes.h>

typedef struct _menu {
    int     type;                       /* Type of menu (action or submenu) */
    char    *label;                     /* Menu label                       */
    int     (*menuproc)(void *);        /* Function if action item          */
    struct _menu *submenu;              /* Submenu if submenu item          */
    struct _menu *next;                 /* Next item at this menu level     */
    RectType region;                    /* Global boundary for this item    */
    int     active;                     /* If False menu item unavailable   */
    short   altkey;                     /* Alt-key combo that selects item  */
    int     keyindex;                   /* Index in label of hotkey char    */
    char    key;                        /* Normal key associated with altkey*/
} MenuType;


#endif
