/*
** smpixmap.h
**
** User header file for pixmaps
**
** Copyright 1992, 1993 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
** Revision history:
**
** 21 April 93
** Original version:
*/

#ifndef SMPIXMAP_H
#define SMPIXMAP_H


#define SMPIXMAPLIMIT   16384           /* Max size of pixmap image         */
#define SMPIXMAPID      101010L         /* File identifier for pixmap image */
#define SMPMNOFILE      1               /* Unable to open pixmap file       */
#define SMPMBADTYPE     2               /* File is not pixmap file type     */

#include <smtypes.h>
#include <smwindop.h>
#include <smpixmpp.h>
#include <smcolor.h>

/*
** Function prototypes
*/

#define SM_SetPixmapBlocking(pm,blk)    ((pm)->blocking = (blk))
#define SM_SetPixmapBorder(pm, bord)    ((pm)->border = (bord))

void        SM_ClearPixmap(PixmapType *dest, ColorType *source);
void        SM_CopyPixmap(PixmapType *dest, PixmapType *source);
PixmapType *SM_CreatePixmap(WindowType *w, RectType *bound, int border);
int         SM_DestroyPixmap(PixmapType *pm);
int         SM_GetPixmapBlocking(PixmapType *pm);
int         SM_GetPixmapDepth(PixmapType *pm);
ColorType  *SM_GetPixmapPixel(PixmapType *pm, int x, int y, ColorType *c);
int         SM_GetPixmapWidth(PixmapType *pm);
void        SM_MovePixmap(PixmapType *pm, int dx, int dy);
PixmapType *SM_ReadPixmap(char *fname);
//void        SM_SetPixmapBlocking(PixmapType *pm, int blocking);
void        SM_SetPixmapPixel(PixmapType *pm, int x, int y, ColorType *c);
int         SM_WritePixmap(PixmapType *pm, char *fname);
int         DrawPixmap(GadgetType *g);

#endif




