/*
** smscroll.h
**
** Header file for scrollbar gadget.
**
**
** Copyright 1993 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
** All rights reserved
**
** Revision history:
**
** 15 June 93
** Original version
*/

#ifndef SMSCROLL_H
#define SMSCROLL_H


#define SCROLLBARUP     1
#define SCROLLBARDOWN   2

#include <smtypes.h>
#include <smscrolp.h>                   /* Scrollbar gadget definition      */
#include <smslider.h>                   /* Scrollbars need slider and       */
#include <smbutton.h>                   /*    Button functionality          */

/*
** Function prototypes
*/
ScrollbarType *SM_CreateScrollbar(
    WindowType  *w,                     /* Parent window                    */
    RectType    *box,                   /* Outline of scrollbar             */
    int         type,                   /* Horizontal or vertical           */
    int         min,                    /* Value at slider min              */
    int         max,                    /* Value at slider max              */
    int         size,                   /* Number of objects for thumbbar   */
    int         initpos,                /* Initial value                    */
    void        *data,                  /* User data                        */
    int         (*slifunc)());          /* Function when slider changes     */

void   *SM_GetScrollbarData(ScrollbarType *s);
int     SM_GetScrollbarMax(ScrollbarType *s);
int     SM_GetScrollbarMin(ScrollbarType *s);
int     SM_GetScrollbarPosition(ScrollbarType *s);
int     SM_GetScrollbarScale(ScrollbarType *s);
void    SM_SetScrollbarChannel(ScrollbarType *s, RectType *box);
void    SM_SetScrollbarData(ScrollbarType *s, void *data);
void    SM_SetScrollbarMinMax(ScrollbarType *s, int min, int max);
void    SM_SetScrollbarPosition(ScrollbarType *s, int p);
void    SM_SetScrollbarProc(ScrollbarType *sb, int (*f)());
void    SM_SetScrollbarScale(ScrollbarType *s, int scale);
int     WinSliderFunction(SliderType *slider);


#endif


