/*
** set.h
*/

#ifndef SMSET_H
#define SMSET_H

/*
** A set data structure
*/

#define UNDEFINED   -32765

typedef struct _set {
    int         item;
    struct _set *next, *prev;
} SetItemType;

typedef struct {
    int         nitems;
    SetItemType *set;
    SetItemType *tail;
} SetType;

SetType    *CreateSet(void);
void        DestroySet(SetType *set);
void        InsertSet(SetType *set, int item);
void        ClearSet(SetType *set);
int         InSet(SetType *set, int item);
void        DeleteSet(SetType *set, int item);
void        ToggleSet(SetType *set, int item);


#endif

