/*
** smslidep.h
**
** Private header file for sliders
**
** Copyright 1994 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
*/

#ifndef SMSLIDEP_H
#define SMSLIDEP_H

#include    <stdio.h>
#include    <smgadgtp.h>
#include    <smtypes.h>

/*
** slider structure definition
*/
typedef struct _sli {
    GadgetType *gadget;                 /* 'Superclass' gadget              */
	RectType thumbbar;                  /* Slide thumbbar region            */
    int     type;                       /* Horizontal or Vertical           */
    int     min;                        /* Slider value at minimum          */
	int     max;                        /* Slider value at maximum          */
    int     scale;                      /* Size of jump in user units       */
    int     position;                   /* min <= position <= max           */
	int     twidth;                     /* Width in pixels of thumbbar      */
    int     pixels;                     /* Number of pixels free movement   */
    int     state;
    double  inc;                        /* Units/pixel for thumbbar moves   */
    void    *data;                      /* User-specified data for button   */
} SliderType;


#endif
