/*
** smslider.h
**
** Copyright 1992, 1993 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
** Public header for slider control.
*/

#ifndef SMSLIDER_H
#define SMSLIDER_H

#include <stdio.h>                      /* For void defintion               */
#include <smslidep.h>                   /* Slider struct definition         */
#include <smgadgtp.h>                   /* Generic gadget definition        */
#include <smwindop.h>                   /* Window definition                */


#define SLIDERTHUMBSTATE    1           /* Slider thumb states              */
#define SLIDERTHUMBDONESTATE 4
#define SLIDERJUMPUPSTATE   2
#define SLIDERJUMPDOWNSTATE 3
#define SLIDERDONESTATE     0


/*
** Function prototypes
*/
SliderType *SM_CreateSlider(
    WindowType  *w,                     /* Parent window                    */
    RectType    *box,                   /* Outline of channel               */
    int         type,                   /* Horizontal or vertical           */
    int         min,                    /* Value at slider min              */
    int         max,                    /* Value at slider max              */
    int         size,                   /* Number of objects for thumbbar   */
    int         initpos,                /* Initial value                    */
    void        *data,                  /* User data                        */
    int         (*function)());         /* Function when slider changes     */
int         SM_DestroySlider(SliderType *s);
void       *SM_GetSliderData(SliderType *s);
int         SM_GetSliderPosition(SliderType *s);
int         SM_GetSliderMin(SliderType *s);
int         SM_GetSliderMax(SliderType *s);
int         SM_SetSliderChannel(SliderType *slider, RectType *box);
int         SM_SetSliderData(SliderType *sl, void *data);
int         SM_SetSliderMinMax(SliderType *s, int min, int max);
int         SM_SetSliderScale(SliderType *s, int scale);
void        SetSliderThumb(SliderType *slider);
void        SM_SetSliderPosition(SliderType *sl, int position);

#endif
