/*
** wintest6.c
**
** Test 6 of the SM window system.
** Test the button gadget, including active/inactive
**
** Copyright 1992, 1993 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
**
** Revision history:
**
** Mon  06-29-1992
** Original version
*/

#include <stdio.h>

#include "smwindow.h"
#include "smevent.h"
#include "smbutton.h"
#include "smcolor.h"
#include "smgraph.h"
#include    <smgadget.h>

extern FILE *ferr;

int ButtonUserproc(ButtonType *b);

#ifdef __TURBOC__
extern unsigned _stklen = 8192U;
#endif

main(int argc, char **argv)
{
    EventType   ev;
    int         msg;
    WindowType  *w;
    ButtonType  *b1, *b2;
    RectType    r;
    int         i = False;
    char        key, code;
    int         k= 0;

    ferr = NULL;
    /*
    ** Initialize the window system, graphics, fonts, etc.
    */
    SM_Init(0,0);

    /*
    ** Open the application
    */
    SM_OpenApplication("TWS Demo : Button Gadget", NULL); /* Create application screen    */

    SM_SetSystemFont("sys16.fnt");
    /*
    ** Create and open an application window
    */
    r.Xmin = r.Ymin = 180;
    r.Xmax = r.Ymax = 400;
    w = SM_NewWindow(&r, "Test Window", DOCUMENT | NOBACKING, NULL, NULL);
    SM_SetContentColor(w, SM_GetSystemColor(SMLIGHTGRAY));

    /*
    ** Add a button before the window is opened
    */
    r.Xmin = r.Ymin = 10;
    r.Xmax = r.Xmin + GR_StringWidth("  Button 1  ");
    r.Ymax = r.Ymin + 24;
    b1 = SM_CreateButton(w,
                         &r,
                         "Button 1",
                         (void *)1,
                         ButtonUserproc);
    SM_OpenWindow(w);

    /*
    ** Add another button after the window has been opened
    */
    r.Ymin = r.Ymax + 8;
    r.Ymax = r.Ymin + 24;
    b2 = SM_CreateButton(w,
                         &r,
                         "Button 2",
                         (void *)2,
                         ButtonUserproc);
    SM_SetButtonIsdefault(b1, True);

    /*
    ** Event loop...
    */
    if (ferr == NULL) {
        ferr = fopen("wintest6.out","wb");
    }

    while (True) {
        SM_GetNextEvent(&ev);
        msg = SM_ProcessEvent(&ev);
        if (msg == KEYPRESS) {
            SM_GetEventKey(&ev, &key, &code);
            if (toupper(key) == 'Q') {
                SM_Exit(NULL);
            }
            SM_SetButtonActive(b2, i);
            i = ~i;
            switch (k) {
                case 0 :
                    SM_SetGadgetBackcolor(b2, SM_GetSystemColor(SMDARKRED));
                    SM_SetGadgetForecolor(b2, SM_GetSystemColor(SMWHITE));
                    break;
                case 1 :
                    SM_SetButtonIsdefault(b1, i);
                    SM_SetGadgetBackcolor(b2, SM_GetSystemColor(SMLIGHTGRAY));
                    SM_SetGadgetForecolor(b2, SM_GetSystemColor(SMBLACK));
                    break;
                case 2 :
                    SM_AdjustGadgetBound(b2, 5, 5, 15, 15);
                    break;
            }
            k++;
            k %=3;
            SM_RefreshGadgets(w);
        }
    }
}

int ButtonUserproc(ButtonType *b)
{
    int n;

    n = (int)SM_GetButtonData(b);
    fprintf(ferr,"Button %d activated!\n", n);
    return True;
}
