/*
** wintestc.c
**
** Test 12 of the SM window system.
** Label test
**
** Copyright 1992, 1993 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
*/

#include <stdio.h>
#include <string.h>

#include "smtypes.h"
#include "smwindow.h"
#include "smevent.h"
#include "smcolor.h"
#include "smgraph.h"
#include "smlabel.h"
#include    <smfont.h>

main(int argc, char **argv)
{
    EventType   ev;
    int         msg;
    WindowType  *w;
    LabelType   *label;
    RectType    rt;

    /*
    ** Initialize the window system, graphics, fonts, etc.
    */
    SM_Init(0,0);

    /*
    ** Open the application
    */
    SM_OpenApplication("TWS Demo : Label Gadget", NULL);

    /*
    ** Create and open an application window
    */
    rt.Xmin = rt.Ymin = 180;
    rt.Xmax = rt.Ymax = 180+247;
    w = SM_NewWindow(&rt, "Test Window 1", DOCUMENT | NOBACKING, NULL, NULL);
    SM_SetContentColor(w, SM_GetSystemColor(SMLIGHTGRAY));

    /*
    ** Create a label
    */
    rt.Xmin = rt.Ymin = 8;
    rt.Xmax = rt.Xmin + GR_StringWidth("              Unboxed Label              ");
    rt.Ymax = rt.Ymin + 6 + SM_GetSystemFontHeight();
    label = SM_CreateLabel(w,
                           &rt,             /* Label bounding box           */
                           "Unboxed Label", /* String for label             */
                           NULL,            /* Label procedure              */
                           SM_GetSystemFont(),
                           ALIGNLEFT,       /* Label string alignment       */
                           False,           /* Bold flag                    */
                           False,           /* Italic flag                  */
                           False,           /* Box flag                     */
                           NULL);           /* User data                    */
    rt.Ymin = rt.Ymax + 8;
    rt.Ymax = rt.Ymin + 6 + SM_GetSystemFontHeight();
    label = SM_CreateLabel(w,
                           &rt,             /* Label bounding box           */
                           "Boxed Label",   /* String for label             */
                           NULL,            /* Label procedure              */
                           SM_GetSystemFont(),
                           ALIGNLEFT,       /* Label string alignment       */
                           False,           /* Bold flag                    */
                           False,           /* Italic flag                  */
                           SCULPTED,        /* Box flag                     */
                           NULL);           /* User data                    */
    rt.Ymin = rt.Ymax + 8;
    rt.Ymax = rt.Ymin + 6 + SM_GetSystemFontHeight();
    label = SM_CreateLabel(w,
                           &rt,             /* Label bounding box           */
                           "Right-Aligned Label",   /* String for label             */
                           NULL,            /* Label procedure              */
                           SM_GetSystemFont(),
                           ALIGNRIGHT,      /* Label string alignment       */
                           False,           /* Bold flag                    */
                           False,           /* Italic flag                  */
                           FLAT,            /* Box flag                     */
                           NULL);           /* User data                    */
    rt.Ymin = rt.Ymax + 8;
    rt.Ymax = rt.Ymin + 6 + SM_GetSystemFontHeight();
    label = SM_CreateLabel(w,
                           &rt,             /* Label bounding box           */
                           "Transparent Background",  /* String for label   */
                           NULL,            /* Label procedure              */
                           SM_GetSystemFont(),
                           ALIGNCENTER,     /* Label string alignment       */
                           False,           /* Bold flag                    */
                           False,           /* Italic flag                  */
                           BEVELED,         /* Box flag                     */
                           NULL);           /* User data                    */
    SM_SetGadgetBackcolor(label, TRANSPARENT);
    /*
    ** Label inside a label
    */
    rt.Ymin = rt.Ymax + 8;
    rt.Ymax = rt.Ymin + 6 + 2*SM_GetSystemFontHeight();
    rt.Xmax += 60;
    label = SM_CreateLabel(w,
                           &rt,             /* Label bounding box           */
                           NULL,            /* Label string                 */
                           NULL,            /* Label procedure              */
                           SM_GetSystemFont(),
                           ALIGNCENTER,     /* Label string alignment       */
                           False,           /* Bold flag                    */
                           False,           /* Italic flag                  */
                           CHISELED,        /* Box flag                     */
                           NULL);           /* User data                    */
    SM_SetGadgetBackcolor(label, SM_GetSystemColor(SMLIGHTBLUE));
    rt.Ymin += 8;
    rt.Ymax -= 8;
    rt.Xmax -= 20;
    rt.Xmin += 20;
    label = SM_CreateLabel(w,
                           &rt,             /* Label bounding box           */
                           NULL,            /* Label string                 */
                           NULL,            /* Label procedure              */
                           SM_GetSystemFont(),
                           ALIGNCENTER,     /* Label string alignment       */
                           False,           /* Bold flag                    */
                           False,           /* Italic flag                  */
                           CHISELED,        /* Box flag                     */
                           NULL);           /* User data                    */
    SM_SetGadgetBackcolor(label, SM_GetSystemColor(SMLIGHTRED));
    SM_OpenWindow(w);

    /*
    ** Event loop...
    */
    while (True) {
        SM_GetNextEvent(&ev);
        msg = SM_ProcessEvent(&ev);
        if (msg == KEYPRESS) {
            SM_Exit(NULL);
        }
    }
}

