/*
** wintestq.c
**
** Borders
**
** Copyright (C) 1994 by
** Dean Clark
** Box 37464
** Albuquerque, NM  87176
** All rights reserved
*/
#include    <stdio.h>
#include    <stdlib.h>

#include    <smwindow.h>
#include    <smborder.h>
#include    <smevent.h>

void PrntScrn(WindowType *w, RectType *r, char *fname);;

int main(int argc, char *argv[])
{
    WindowType  *w;
    RectType    r;
    int         msg;
    EventType   ev;

    SM_Init(0,0);
    SM_OpenApplication("TWS Demo : Borders", NULL);
    w = SM_WorkspaceWindow();

    r.Xmin = r.Ymin = 75;
    r.Xmax = r.Xmin + 250;
    r.Ymax = r.Ymin + 125;
    SM_CreateBorder(w, &r, "Flat", twsBORDERLEFT, twsBORDERBOX, twsBORDERFLAT, 1, SM_GetSystemColor(SMDARKGRAY));
    r.Xmin = r.Xmax + 10;
    r.Xmax = r.Xmin + 200;
    SM_CreateBorder(w, &r, "Beveled", twsBORDERCENTER, twsBORDERBOX, twsBORDERBEVEL, 1, SM_GetSystemColor(SMDARKGRAY));
    r.Xmin = 75;
    r.Ymin = r.Ymax + 25;
    r.Xmax = r.Xmin + 250;
    r.Ymax = r.Ymin + 125;
    SM_CreateBorder(w, &r, "Sculpted", twsBORDERRIGHT, twsBORDERBOX, twsBORDERSCULPT, 1, SM_GetSystemColor(SMDARKGRAY));
    r.Xmin = r.Xmax + 10;
    r.Xmax = r.Xmin + 200;
    SM_CreateBorder(w, &r, "Ridged", twsBORDERLEFT, twsBORDERBOX, twsBORDERLRIDGE, 1, SM_GetSystemColor(SMDARKGRAY));
    r.Xmin = 75;
    r.Ymin = r.Ymax + 25;
    r.Ymax = r.Ymin + 5;
    r.Xmax = r.Xmin + 250;
    SM_CreateBorder(w, &r, "Sculpt", twsBORDERLEFT, twsBORDERHLINE, twsBORDERSCULPT, 1, SM_GetSystemColor(SMDARKGRAY));
    r.Ymin += 15;
    r.Ymax += 15;
    SM_CreateBorder(w, &r, "Flat", twsBORDERCENTER, twsBORDERHLINE, twsBORDERFLAT, 1, SM_GetSystemColor(SMDARKGRAY));
    r.Ymin += 15;
    r.Ymax += 15;
    SM_CreateBorder(w, &r, "Bevel", twsBORDERRIGHT, twsBORDERHLINE, twsBORDERBEVEL, 1, SM_GetSystemColor(SMDARKGRAY));
    r.Ymin += 15;
    r.Ymax += 15;
    SM_CreateBorder(w, &r, "Ridge", twsBORDERLEFT, twsBORDERHLINE, twsBORDERLRIDGE, 1, SM_GetSystemColor(SMDARKGRAY));

    r.Xmin = 575;
    r.Ymin = 75;
    r.Ymax = r.Ymin + 205;
    r.Xmax = r.Xmin + 15;
    SM_CreateBorder(w, &r, NULL, twsBORDERLEFT, twsBORDERVLINE, twsBORDERSCULPT, 1, SM_GetSystemColor(SMDARKGRAY));
    r.Xmin += 15;
    r.Xmax += 15;
    SM_CreateBorder(w, &r, NULL, twsBORDERLEFT, twsBORDERVLINE, twsBORDERFLAT, 1, SM_GetSystemColor(SMDARKGRAY));
    r.Xmin += 15;
    r.Xmax += 15;
    SM_CreateBorder(w, &r, NULL, twsBORDERLEFT, twsBORDERVLINE, twsBORDERBEVEL, 1, SM_GetSystemColor(SMDARKGRAY));
    r.Xmin += 15;
    r.Xmax += 15;
    SM_CreateBorder(w, &r, NULL, twsBORDERLEFT, twsBORDERVLINE, twsBORDERRIDGE, 1, SM_GetSystemColor(SMDARKGRAY));

    SM_SetPrintscreenProc(NULL, NULL, "border.pcx", PrntScrn);

    while (True) {
        SM_GetNextEvent(&ev);
        msg = SM_ProcessEvent(&ev);
        if (msg == KEYPRESS) {
            if (ev.ASCII == 'q') {
                SM_Exit(NULL);
            }
        }
    }
}


void PrntScrn(WindowType *w, RectType *r, char *fname)
{
    SM_SaveScreenAsPCX(fname);
}


