/*
** wintests.c
**
** TWS demo program for window icons
**
** Copyright 1995 by
** Dean Clark
** PO Box 37464
** Albuquerque, NM  87176
*/

#include    <stdio.h>
#include    <stdlib.h>

#include    <smwindow.h>
#include    <smicon.h>
#include    <smpixmap.h>
#include    <smevent.h>

int main(int argc, char *argv[])
{
    WindowType  *w, *w2;
    PixmapType  *iconpixmap;
    RectType    winrect;
    int         msg;
    EventType   event;

    /*
    ** Initialize the graphics and window systems
    */
    SM_Init(0,0);

    /*
    ** Initialize the application
    */
    SM_OpenApplication("TWS Demo : Window Icons", NULL);

    /*
    ** Create a window
    */
    winrect.Xmin = winrect.Ymin = 150;
    winrect.Xmax = winrect.Xmin + 250;
    winrect.Ymax = winrect.Ymin + 200;
    w = SM_NewWindow(&winrect,          /* Window content rectangle         */
                     "Sharing...",       /* Window title                     */
                     DOCUMENT,          /* Window attributes                */
                     NULL,              /* Window data pointer              */
                     NULL);             /* Window menu                      */
    winrect.Xmin += 25;
    winrect.Ymin += 25;
    winrect.Xmax += 25;
    winrect.Ymax += 25;
    w2 = SM_NewWindow(&winrect,          /* Window content rectangle         */
                     "...Pixmaps",       /* Window title                     */
                     DOCUMENT,          /* Window attributes                */
                     NULL,              /* Window data pointer              */
                     NULL);             /* Window menu                      */

    /*
    ** Initialize the icon pixmap -- read a pixmap file, attach the icon
    ** to the window
    */
    iconpixmap = SM_ReadPixmap("..\\icons\\face.icn");
    SM_CreateIcon(w,                    /* Window to get icon               */
                  NULL,                 /* Icon label, or use window title  */
                  iconpixmap);          /* Pixmap                           */
    SM_CreateIcon(w2,
                  NULL,
                  iconpixmap);

    /*
    ** Display the window and enter the event loop
    */
    SM_OpenWindow(w);
    SM_OpenWindow(w2);
    while (1) {
        SM_GetNextEvent(&event);
        msg = SM_ProcessEvent(&event);
        if (msg == KEYPRESS) {
            SM_Exit(NULL);
        }
    }
}

